// this header is designed for Borland C++ Builder
// see details in ExtType.pas

#include <System.hpp>

#pragma option push -w-
#pragma option push -Vx

//-- user supplied -----------------------------------------------------------

namespace Exttypes
{
//-- type declarations -------------------------------------------------------
typedef unsigned DWord;

typedef unsigned ULong;

typedef short Small;

typedef int Integer;

typedef Shortint Short;

typedef int Long;

typedef int *PLong;

typedef Shortint *PShort;

typedef short *PSmall;

typedef unsigned *PDWord;

typedef unsigned *PULong;

typedef float Float;

typedef float *PFloat;

typedef WideString WString;

typedef wchar_t WChar;

typedef AnsiString *PString;

typedef WideString *PWString;

typedef wchar_t *PWChar;

typedef unsigned THandle;

#pragma pack(push, 1)
struct TVersionInfo
{

	union
	{
		struct 
		{
			unsigned Version;
			
		};
		struct 
		{
			Byte Major;
			Byte Minor;
			Word Build;
			
		};
		
	};
} ;
#pragma pack(pop)

enum TPlatform { pfUnknown, pfWin32, pfWin64, pfLinux, pfIndependent };


#pragma pack(push, 1)
struct TMsgRec
{
	unsigned MsgID;
	System::TObject* Sender;
	union
	{
		struct 
		{
			char Chars[4];
			
		};
		struct 
		{
			Byte Bytes[4];
			
		};
		struct
		{
			Word Words[2];
			
		};
		struct
		{
			int LParam;
			
		};
		struct 
		{
			unsigned ULParam;
			
		};
		struct
		{
			void *Data;
			
		};
		
	};
} ;
#pragma pack(pop)

typedef char TIDCode[8];

enum TModuleStyle { msInternal, msLowLevel, msAbsWrapper, msInterface, msClassInst, msClassRef };

#pragma pack(push, 1)
struct TModuleInfo
{
	char Name[32];
	char Description[96];
	char LibName[32];
	char Creator[64];
	char Language[16];
	char IDCode[8];
	TModuleStyle Style;
	TVersionInfo Version;
	TPlatform Platform;
	bool RequiresLib;
} ;
#pragma pack(pop)

typedef TModuleInfo *PModuleInfo;

typedef void __cdecl (*TModuleCountProc)(int &Count);

typedef void __cdecl (*TModuleInfoProc)(int Index, TModuleInfo &Info);

typedef void __cdecl (*TModuleExtInfoProc)(int Index, void * &ExtInfo);

typedef bool __fastcall (*TCompressBufferProc)(void * InData, int InSize, void * &OutData, int &OutSize);

typedef bool __fastcall (*TDecompressBufferProc)(void * InData, int InSize, void * &OutData, int &OutSize);

#pragma pack(push, 1)
struct TExtCompressInfo
{
	bool CanCompress;
	bool CanDecompress;
	TCompressBufferProc CompressBuffer;
	TDecompressBufferProc DecompressBuffer;
} ;
#pragma pack(pop)

typedef TExtCompressInfo *PExtCompressInfo;

//-- var, const, procedure ---------------------------------------------------
#define sModuleCount "ModuleCount"
#define sModuleInfo "ModuleInfo"
#define sModuleExtInfo "ModuleExtInfo"
#define sModuleFileMask "mod*.*"

#define sCompressModuleID "CMP"
#define sImageModuleID "IMG"

}	/* namespace Exttypes */
using namespace Exttypes;
#pragma option pop	// -w-
#pragma option pop	// -Vx


//-- end unit ----------------------------------------------------------------



