// this header is designed for MS Visual C++
// for details see ExtTypes.pas

namespace Exttypes
{
//-- type declarations -------------------------------------------------------
typedef unsigned DWord;

typedef unsigned ULong;

typedef short Small;

typedef int Integer;

typedef short Short;

typedef int Long;

typedef int *PLong;

typedef short *PShort;

typedef short *PSmall;

typedef unsigned *PDWord;

typedef unsigned *PULong;

typedef float Float;

typedef float *PFloat;

//typedef WideString WString;

typedef wchar_t WChar;

//typedef AnsiString *PString;

//typedef WideString *PWString;

typedef wchar_t *PWChar;

typedef unsigned THandle;

#pragma pack(push, 1)
struct TVersionInfo
{

	union
	{
		struct 
		{
			unsigned Version;
			
		};
		struct 
		{
			char Major;
			char Minor;
			unsigned short Build;
			
		};
		
	};
} ;

#pragma pack(pop)


enum TPlatform { pfUnknown, pfWin32, pfWin64, pfLinux, pfIndependent };


#pragma pack(push, 1)
struct TMsgRec
{
	unsigned MsgID;
	void  *Sender;
	union
	{
		struct 
		{
			char Chars[4];
			
		};
		struct 
		{
			char Bytes[4];
			
		};
		struct 
		{
			unsigned short Words[2];
			
		};
		struct
		{
			int LParam;
			
		};
		struct 
		{
			unsigned ULParam;
			
		};
		struct 
		{
			void *Data;
			
		};
		
	};
} ;
#pragma pack(pop)

typedef char TIDCode[8];

typedef enum TModuleStyle { msInternal, msLowLevel, msAbsWrapper, msInterface, msClassInst, msClassRef };

#pragma pack(push, 1)
struct TModuleInfo
{
	char Name[32];
	char Description[96];
	char LibName[32];
	char Creator[64];
	char Language[16];
	char IDCode[8];
	TModuleStyle Style;
	TVersionInfo Version;
	TPlatform Platform;
	bool RequiresLib;
} ;
#pragma pack(pop)

typedef TModuleInfo *PModuleInfo;

typedef void (__cdecl *TModuleCountProc)(int &Count);

typedef void (__cdecl *TModuleInfoProc)(int Index, TModuleInfo &Info);

typedef void (__cdecl *TModuleExtInfoProc)(int Index, void * &ExtInfo);

typedef bool (__cdecl *TCompressBufferProc)(void * InData, int InSize, /* out */ void * &OutData, /* out */ int &OutSize);

typedef bool (__cdecl *TDecompressBufferProc)(void * InData, int InSize, /* out */ void * &OutData, /* out */ int &OutSize);

#pragma pack(push, 1)
struct TExtCompressInfo
{
	bool CanCompress;
	bool CanDecompress;
	TCompressBufferProc CompressBuffer;
	TDecompressBufferProc DecompressBuffer;
} ;
#pragma pack(pop)

typedef TExtCompressInfo *PExtCompressInfo;

//-- var, const, procedure ---------------------------------------------------
#define sModuleCount "ModuleCount"
#define sModuleInfo "ModuleInfo"
#define sModuleExtInfo "ModuleExtInfo"
#define sModuleFileMask "mod*.*"

#define sCompressModuleID "CMP"
#define sImageModuleID "IMG"

}	/* namespace Exttypes */
using namespace Exttypes;


//-- end unit ----------------------------------------------------------------

